// -*- c++ -*-
#ifndef AKAXISO2_XML_DESERIALIZER_CHOICE_HANDLER_H__
#define AKAXISO2_XML_DESERIALIZER_CHOICE_HANDLER_H__

#include <akaxiso2/XML/deserializer/handler.h>

namespace aka2 {
  
  class choice_handler : public handler {
  public:
    choice_handler(bool emptiable, void *cho, const choice_op &cop,
		   int depth,
		   const element_props &props,
		   parser_context &context);
    virtual ~choice_handler();
    virtual validation_result query_element(const qname &tagname, const attribute_values &attrs);
    virtual validation_result end_element(const qname &tagname);
    virtual validation_result query_next(const qname &tagname, const attribute_values &attrs);
    virtual bool parse_entity(const pstring &entity);
    
    virtual node get_node();
    virtual void receive_child(const node &child);
    
    virtual bool can_skip();
    virtual void abort();
  private:
    validation_result parse_element(const attribute_values &attrs);
    validation_result find_particle(const qname &tagname, const attribute_values &attrs,
				    const itemtype ** found,
				    void **ep, bool &emptiable);
    void *cho_;
    void *e_;
    const choice_op &cop_;
    const occurrence &occurrence_;
    int count_;
    const item_types &itypes_;
    const itemtype *current_;
    item_types::const_iterator searching_;
  };

}

#endif

